/* Copyright (c) 2010 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne licenese GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor argumenty.c */

#include <string.h>
#include <unistd.h>
#include <getopt.h>
#include "definice.h"
#include "struktury.h"
#include "lib.h"

#define BSCHEMAT (7)

char *argumenty(int argc, char **argv)
{
    char opt;
    char *text_napovedy;
    int i;
    char *navrat = NULL;

    for (i = 0; i < argc; i++)
        if (strlen(argv[i]) >= 512) {
            /* z bezpenostnch dvod */
            fprintf(stderr, "Pli dlouh argument:\n%s\n", argv[i]);
            exit(0);
        }

    global_set(g_barva, 0);     /* 0 znamena standardni barvy */

    while ((opt = getopt(argc, argv, "HhvcC:f:wiax")) != -1) {
        switch (opt) {
        case 'H':
            text_napovedy = text_n2();
            i = 0;
            do {
                if (text_napovedy[i] != '' && text_napovedy[i] != '|')
                    printf("%c", text_napovedy[i]);
            }
            while (text_napovedy[i++] != '\0');
            exit(0);
        case 'h':
            printf("pouziti: " NAZEV1 "-" VER " [OPTION]\n"
                   "OPTION:\n"
                   "-f soubor\tpsani \"nove lekce\" ze souboru\n"
                   "-c\t\tbilocerny monitor (totez co -C 7)\n"
                   "-C barva\tbarevne schema monitoru se zadanou barvou (barva = <0,%i>)\n"
                   "-x\t\tboxy nepouziji spec. znaky \n"
                   "-w\t\tbudou se zobrazovat varovani programu (warning on)\n"
                   "-i\t\tvypne se internetova komunikace\n"
                   "-a\t\tzobrazi se soubory a adresare vyuzivane programem\n",
                   BSCHEMAT);
            printf(             /* iso c spolkne max 507 znaku v retezci, tak to printnu 2x */
                      "-H\t\tuplna napoveda k programu\n"
                      "-v\t\tverse programu\n"
                      "-h\t\ttato napoveda\n\n%s\n",
                      "Tento program podleha licenci GNU vydavane FreeSoftware Foundation.\n"
                      "(c) 2002 - " ROK " Petr Bilek, Kladno II\n");
            exit(0);
        case 'v':
            printf("%s ver %s (%u)\n", NAZEV1, VER, CISLOPREKLADU);
            exit(0);
        case 'c':
            global_set(g_barva, 7);     /* 7 znamena cernobily vystup */
            break;
        case 'd':
            global_set(g_barva, 17);    /* 17 znamena defaultni barvy */
            break;
        case 'x':
            global_set(g_box, 1);
            break;
        case 'C':
            i = atoi(optarg);
            if ((i < 0) || (i > BSCHEMAT)) {
                fprintf(stderr, "barva = <0,%i>\n", BSCHEMAT);
                exit(1);
            }
            /* cislo barevneho schematu */
            global_set(g_barva, i);
            break;
        case 'f':
            navrat = optarg;
            break;
        case 'w':
            global_set(g_warning, g_w_ano);
            break;
        case 'i':
            global_set(g_disable_inet, g_w_ano);
            break;
        case 'a':
            printf("adresar:\t%s\n", jmeno_adresare());
            printf("slozka:\t\t%s\n", jmeno_souboru());
            printf("nastaveni:\t%s\n", jmeno_souboru_nastaveni());
            printf("lock:\t\t%s\n", jmeno_temp_soubor());
            printf("hlavni:\t\t%s\n", jmeno_adresare_hlavni());
            printf("menu:\t\t%s\n", jmeno_menu());
            printf("napoveda:\t%s\n", jmeno_napovedy());
            printf("TIP:\t\t%s\n", jmeno_napovedy3());
            printf("infolekce:\t%s\n", jmeno_info_lekce());
            printf("infotest:\t%s\n", jmeno_info_testu());
            printf("lekce_help:\t%s\n", jmeno_napovedy_lekce(0));
            printf("test_help:\t%s\n", jmeno_napovedy_testu(0));
            printf("lekce:\t\t%s\n", jmeno_lekce00());
            printf("test:\t\t%s\n", jmeno_testu00());
            exit(0);
            break;
        default:
            fprintf(stderr, "zadej: %s -h\t pro napovedu.\n", NAZEV1);
            exit(1);
            break;
        }
    }
    return navrat;
}
