/* Copyright (c) 2002 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor menu.c */

#include <unistd.h>
#include <stdlib.h>
#include <errno.h>
#include "strukturyw.h"
#include "struktury.h"
#include "libw.h"
#include "lib.h"
#include "priorita.h"

int getch3(void)
{
    static int nap = 0;         /* napoveda je spustena */
    static int kla = 0;         /* zobrazeni klavesnice je spusteno */
    int ch;
    int intrpt = 0;
    do {
        if ((ch = getch2()) == ERR) {
            print_hl(1, "Chyba ten klvesnice!");
            intrpt++;
            if (errno != EINTR || intrpt > 10) {        /* v gdb pri zmene velikosti xtermu dochazi k EINTR */
                if (global_get(g_warning) == g_w_ano)
                    fprintf(stderr, "getch3() vratil ERR\n");
                konec(strerror(errno));
            }
            /* TODO:sleep pul vteriny */
            continue;
        }

        if (global_get(g_qwertz) == g_q_z)
            switch (ch) {
            case 'y':
                ch = 'z';
                break;
            case 'Y':
                ch = 'Z';
                break;
            case 'z':
                ch = 'y';
                break;
            case 'Z':
                ch = 'Y';
                break;
            }

        if ((global_get(g_us) == g_us_us) && (ch != '\0')) {
            ch = ustocz(ch);
            if (ch == '\0')     /* hacek nebo carka */
                continue;
        }

        switch (ch) {
        case KEY_F(1):
            if (!nap) {
                nap++;
                napoveda();
                nap = 0;
            }
            break;
        case KEY_F(2):
            if (!kla) {
                kla++;
                klavesnice();
                kla = 0;
            }
            break;
        case KEY_F(4):
            redrawwin2(stdscr);
            print_hl(1, "Obrazovka vyitna");
            tiskni_dle_priority();
            break;
        case KEY_F(12):
            return KEY_BACKSPACE;
        case KEY_F(3):
        case KEY_F(5):
        case KEY_F(6):
        case KEY_F(7):
        case KEY_F(9):
            break;              /* ignorujeme tyto klavesy */
        case KEY_F(10):
            if (global_get(g_run) == g_run_t)
                print_hl(1,
                         "Psan testu nelze ukonit! Pili by jste tak o 1 pokus!");
            else
                konec("Goodbye!");
            break;
        default:
            return ch;
        }
    }
    while (1);

    return '?';
}
