/* Copyright (c) 2002 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor main.c */

#include <unistd.h>
#include <stdlib.h>
#include <locale.h>
#include <errno.h>
#include "definice.h"
#include "strukturyw.h"
#include "struktury.h"
#include "libw.h"
#include "lib.h"
#include "menu.h"

type_odstavec odstavec;
type_uziv slozka;
type_nastaveni nastaveni;
char chyba_polozky[80];


void main_lekce(int prvni, int posledni)
{
    if (posledni > MAXLEKCE)
        posledni = MAXLEKCE;
    if (prvni > posledni)
        prvni = posledni;

    do {
        odstavec.lekce = vyber_lekci(&slozka, &nastaveni, prvni, posledni);
        if (odstavec.lekce) {
            if (!inicializuj_lekci(&slozka, &odstavec))
                if (!spust_lekci(&slozka, &nastaveni, &odstavec)) {
                    obnov_nadpis1(&slozka, &nastaveni);
                    return;
                }
        } else
            return;
    }
    while (1);
}

void main_test(int prvni, int posledni)
{
    if (posledni > MAXTEST)
        posledni = MAXTEST;

    if (prvni > posledni)
        prvni = posledni;

    do {
        odstavec.lekce = vyber_test(&slozka, &nastaveni, prvni, posledni);
        if (odstavec.lekce) {
            if (!inicializuj_test(&slozka, &odstavec))
                if (!spust_test(&slozka, &nastaveni, &odstavec)) {
                    obnov_nadpis1(&slozka, &nastaveni);
                    return;
                }
        } else
            return;
    }
    while (1);
}

/*-------------------------------------------------------------------------*/
int main(int argc, char *argv[])
{
    char *chyba;
    enum_menu men;
    int i;
    char *nov_text;
    char *betaverse[] = { " !!! TOTO JE BETAVERZE PROGRAMU !!!\n",
        "               < OK >"
    };
    char *chybaprihlaseni[] = { NULL, "\n\n                < OK >"
    };

    if ((setlocale(LC_ALL, "") == NULL) &&
        (global_get(g_warning) == g_w_ano))
        perror("setlocale()");

    /* inicializace global_semafor_init musi byt pred prvnim vyuzitim
     * global-funkce. Prvni vyuziti global-funkce je uz ve funkci
     * argumenty() */
    if ((i = global_semafor_init()) != 0) {
        fprintf(stderr, "Selahalala inicializace %i vlaken.", i);
        exit(errno);
    }

    if (curses_semafor_init() || button_semafor_init()) {
        fprintf(stderr, "Nelze inicializovat semafory\n");
        exit(errno);
    }

    nov_text = argumenty(argc, argv);
    root_varovani();            /* z bezpecnostnich duvodu by nemel root
                                   program spoustet */
    signal_nastavit();

    if (windows(&chyba, &slozka)) {     /* inicializuji se tam curses */
        fprintf(stderr, "CHYBA: %s\n", chyba);
        exit(EXIT_FAILURE);
    }
/* odsud jiz nelze pouzivat exit() ale jen konec() */

    /* nacteni polozek menu pro lekce a testy ze souboru napoveda/menu */
    (void) nacti_vyber_lt();

    /* nacitaji se soubory */
    if ((prihlaseni(&chyba, &slozka, &nastaveni))) {
        chybaprihlaseni[0] = chyba;
        (void) button(chybaprihlaseni, 2, 1, 5, 39, ((LINES - 5) / 2) - 3,
                      ((COLS - 39) / 2) - 1);
        konec("Hups!");
    }
    obnov_nadpis1(&slozka, &nastaveni);
    vlakna(&slozka, &nastaveni);

    print_hl(1, "\n" NAZEV1 " ver " VER
             ", Copyright(c) 2002 - " ROK " Petr Blek, Kladno II\n");
    print_hl(1,
             "Tento program  podlh  licenci GNU a  nevztahuj se na nj  DN  ZRUKY.");
    print_hl(1,
             "Veker prva a povinnosti vyuvn tohoto programu a jeho zdrojovho kdu\n"
             "se dotete v Obecn veejn licenci GNU, vydvan  FreeSoftware Foundation.");

    if (BETAVERSE && (global_get(g_warning) == g_w_ano))
        (void) button(betaverse, 2, 1, 4, 38, ((LINES - 4) / 2) - 2,
                      ((COLS - 38) / 2) - 2);

    if ((nov_text) != NULL) {
        do {
            if (!inicializuj_nov_text(&odstavec, nov_text)) {
                if (spust_nov_text(&slozka, &nastaveni, &odstavec)) {
                    obnov_nadpis1(&slozka, &nastaveni);
                    break;
                }
            } else
                break;
        }
        while (1);
        konec(NULL);
    }

    men = e_lekce0;

    do {
        men = menu(&slozka, &nastaveni, men);
        switch (men) {
        default:
            if ((men >= 0) && (men <= 11)) {
                switch (vyber_lt[men].fce) {
                case 'l':
                    main_lekce(vyber_lt[men].min, vyber_lt[men].max);
                    break;
                case 't':
                    main_test(vyber_lt[men].min, vyber_lt[men].max);
                    break;
                default:
                    snprintf(chyba_polozky,
                             sizeof(chyba_polozky) / sizeof(char),
                             "FUNKCE %2i:\tTyto lekce/testy nejsou k dispozici.",
                             men);
                    print_hl(1, chyba_polozky);
                    break;
                }
                break;
            }
        case e_null:
            snprintf(chyba_polozky, sizeof(chyba_polozky) / sizeof(char),
                     "FUNKCE %2i:\tTato funkce jet nen k dispozici.",
                     men);
            print_hl(1, chyba_polozky);
            break;
        case e_vysledky:
            vysledky(&slozka);
            break;
        case e_napoveda:
            napoveda();
            break;
        case e_klavesnice:
            klavesnice();
            break;
        case e_konec:
            snprintf(chyba_polozky, sizeof(chyba_polozky) / sizeof(char),
                     "Program jste spustili %i-krt.",
                     abs(nastaveni.spusteno));
            konec(chyba_polozky);
            break;
        case e_nastavenivt:
            nast_nov_text(&nastaveni);
            break;
        case e_vt:
            if (!inicializuj_nov_text(&odstavec, NULL)) {
                if (!spust_nov_text(&slozka, &nastaveni, &odstavec)) {
                    obnov_nadpis1(&slozka, &nastaveni);
                    break;
                }
            }
            obnov_nadpis1(&slozka, &nastaveni);
            tiskni_dle_priority();
            break;
        case e_metronom:
            nast_metronom(&nastaveni);
            obnov_nadpis1(&slozka, &nastaveni);
            break;
        case e_qwertz:
            qwertz(&nastaveni);
            break;
        case e_copyright:
            copyright();
            break;
        }
    }
    while (1);
}

void konec(char *text)
{
    print_hl(1,
             "\nDkuji, e jste se rozhodli pouvat tento program (-;. Pokud se vm program"
             "\nlb, napite mi, prosm, odkud jste a jakou verzi programu pouvte.");
    if (text)
        print_hl(2, text, "\n");
    else
        print_hl(1, "\n");
    echo2();
    vlakna_konec();
    odeber_z_priority(new_hlavni);
    delwin2(new_hlavni);
    endwin2();
    curses_semafor_destroy();
    button_semafor_destroy();
    global_semafor_destroy();
    odemkni();
    if (text)
        printf("\n%s\n", text);
    printf("Nashledanou!\n");

    exit(EXIT_SUCCESS);
}
